
module alu(
  input [15:0] a, b, pc,
  input [9:0] im10,
  output reg [15:0] d,
  input [2:0] opcode
);

`include "opcodes.txt"

wire [15:0] seim = im10[6]? {9'h1FF,im10[6:0]}:{9'h000,im10[6:0]};
wire [15:0] sum = a +  seim;

always
case (opcode)
ADD:
	d <= a + b;
ADDI:
	d <= sum;
NAND:
	d <= ~(a&b);
LUI:
	d <= {im10,6'h00};
SW:
	d <= sum;
LW:
	d <= sum;
BNE:
	d <= pc+seim;
JALR:
	d <= pc;
endcase

endmodule
